/*
 * MyBuffer.c
 */

#include <stdio.h>
#include "MyBuffer.h"

/* #define DEBUG */
#ifdef	DEBUG
#define	BUFSIZE	8
#else
#define	BUFSIZE	10000
#endif
#define	MAXSIZE	((BUFSIZE)*4)
typedef short int recorddata;
static recorddata data[MAXSIZE];
static recorddata buf[BUFSIZE];
static int dataincore = 0;
static int datainfile = 0;
static int ptrincore = 0;
static int ptrinbuf = 0;
static int ptrindata = 0;
static FILE *fp;

void clear_queue(void)
{
    if (datainfile) {
        fclose(fp); datainfile = 0;
    }
    dataincore = 0;
}

int record(int c)
{
    if (dataincore < MAXSIZE)
	data[dataincore++] = c;
    else {
	if (!datainfile) {
	    if ((fp = tmpfile()) == NULL) {
		fprintf(stderr, "cannot open tmpfile\n");
		return 1;
	    }
	}
	if (fwrite(data, sizeof(recorddata), MAXSIZE, fp) < 0) {
	    fprintf(stderr, "fwrite error\n"); fclose(fp);
	    return 2;
	}
	datainfile += MAXSIZE;
	dataincore = 0;
	data[dataincore++] = c;
    }
    return 0;
}

int startreading(void)
{
    ptrincore = 0;
    ptrinbuf = BUFSIZE;
    ptrindata = 0;
    if (datainfile) fseek(fp, 0L, 0);
    return datainfile + dataincore;
}

void finishreading(void)
{
    if (datainfile) fseek(fp, 0L, 2);
}

int readdata(void)
{
    if (ptrindata++ >= datainfile)
	return data[ptrincore++];
    else if (ptrinbuf < BUFSIZE)
	return buf[ptrinbuf++];
    else if (fread(buf, sizeof(recorddata), BUFSIZE, fp) > 0) {
	ptrinbuf = 0;
	return buf[ptrinbuf++];
    }
    else {
	ptrincore = 0;
	return data[ptrincore++];
    }
}
