/*            *
 *   fern.c   *
 *            */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "fplot.h"

#ifndef	RAND_MAX
#define RAND_MAX 0x7fffffff
#endif

double  a[] = { 0   ,  0.85,  0.2 , -0.15 },
        b[] = { 0   ,  0.04, -0.26,  0.28 },
        c[] = { 0   , -0.04,  0.23,  0.26 },
        d[] = { 0.16,  0.85,  0.22,  0.24 },
        e[] = { 0   ,  0   ,  0   ,  0    },
        f[] = { 0   ,  1.6 ,  1.6 ,  0.44 };

#define N (sizeof a / sizeof a[0])
#define M (25 * N)

int main()
{
    int i, j, k, r, ip[N], table[M];
    double x, y, s, t, p[N];

    printf("N=%ld,M=%ld\n", N,M);
    s = 0;
    for (i = 0; i < N; i++) {
	p[i] = fabs(a[i] * d[i] - b[i] * c[i]);
	s +=p[i];  ip[i] = i;
    }
    for (i = 0; i < N - 1; i++) {
	k = i;
	for (j = i + 1; j < N; j++)
	    if (p[j] < p[k]) k = j;
	t = p[i]; p[i] = p[k];  p[k] = t;
	r = ip[i];  ip[i] = ip[k]; ip[k] = r;
    }
    r = M;
    for (i = 0; i < N; i++) {

	k = (int)(r * p[i] / s + 0.5);  s -= p[i];
	do { table[--r] = ip[i];  } while (--k > 0);
    }
    openpl();
    fspace(-5.0, 0.0, 5.0, 10.0);
    x = y = 0;
    for ( i = 0; i< 30000; i++) {
#ifdef  NO
	fprintf (stderr, "m + 1 = %d\n", M + 1);
	fprintf (stderr, "rand_max = %d\n", RAND_MAX);
	fprintf (stderr, "rand_max / m + 1 = %f\n", ((double)RAND_MAX / M + 1));
	fprintf (stderr, "rand = %d\n", rand());
	fprintf (stderr, "table = %d \n", (int)((double)rand() / (RAND_MAX / M + 1)));
#endif
	j = table[(int)(rand() / (RAND_MAX / M + 1))];
#ifdef NO
	fprintf (stderr, "table = %d \n", (int)(rand() / (RAND_MAX / M + 1)));
#endif
	t = a[j] * x + b[j] * y + e[j];
	y = c[j] * x + d[j] * y + f[j];
	x = t;
	if (i >= 10)  {
	    fpoint(x,y);
	}
    }
    mkplot("fern.plot");
    printf("描画終了\n");
    closepl();
    return 0;
}

/*    
static long next = 1;

rand()
{
    next = next * 1103515245L + 12345;
    return ((next / 65536L) % 32768U);
}
*/	

